[Leetcode]Test1 TwoSum [java]题目分析解答

题目

Given an array of integers, return indices of the two numbers such that they add up to a specific target.You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

题目分析:

这里意思是给一个数组和一个数,要求找出数组中两个数之和等于这个数。

tips:

这里题目指出只能有一个唯一的答案且不可以用相同的元素两次。

思路:

这道题我没用什么特殊技巧,暴力解法,两个循环,找到相加等于target的两个数。

public class Test1TwoSum {
	 public int[] twoSum(int[] nums, int target) {
	        for (int i = 0; i < nums.length; i++) {
	            for (int j = 0; j < nums.length; j++) {
	                if(nums[i] + nums[j] == target &&
	                        i != j) {
	                    return new int[] {i, j};
	                }
	            }
	        }
	        return new int[] {};
	    }
}


然后我发现竟然还有一堆人只用了8ms,而我用了43ms。所以借鉴了一下HashMap的做法。HashMap是一个比较消耗空间的做法,但是相对的会节省时间。

public class Solution {
    // if there is solution, with exactly one solution
    // element in array can not be used twice
    /* array is not ordered */
    public int[] twoSum(int[] nums, int target) {
        if(nums == null || nums.length == 0) return new int[]{-1, -1};
        HashMap<Integer,Integer> map = new HashMap<>();
        
        for (int i = 0; i < nums.length; i++) {
            // put element into hashtable and check whether there is a solution
            // numbers  -> index
            if(map.containsKey(target -nums[i])) {
                // has solution
                return new int[]{map.get(target -nums[i]), i};
            }
            map.put(nums[i], i);
        }
 
        // no solution
        return new int[]{-1, -1};
    }
}






  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值